////// SEARCH
var watch = {};
var search = function() {
  //// SEARCH FETCH
  // get results from params
  var searchFetch = function() {

    // change url with new parameters
    if (!fetch_init) { fetch_init = true; }
    else { searchState(params); }

    $.ajax({
      url:"/search/fetch",
      type: 'get',
      data: params.get_fetch(),
      beforeSend: function() {
          $('.result-bar').hide();
          $("#search-fetch").empty();
        $('#search-fetch').append('<div class="search-loading" style="text-align:center;"><br><div class="pong-loader">Carregando...</div></div>');
      }
    })
      .done(function (data) {
          $("#search-fetch").empty();
          $('.result-info-count').html($(data).filter('input:hidden[name="learning-objects-count"]').val());
          $('.result-bar').show();

        $("#search-fetch").append(data);

        // add tooltip
        $('[data-toggle="tooltip"]').tooltip();
      });
  }

  //// SEARCH WATCHERS
  // get initial params from url and watch inputs for params
  var searchWatchers = function() {
    var intervalId = 0;
    var has_init = false;

    if (!has_init) {
      init();
      has_init = true;
    }

    function init() {
      // watch params to change inputs
      watchParams();

      // check url and set params
      checkUrl();

      // watch inputs to change params
      watchSearchInput();
      watchFilterPanel();
      watchOrder();
      watchFilters();
    }

    // get parameters from url when page is loaded
    function checkUrl() {
      if (history.state.search_params !== undefined) {
        params.reload(history.state.search_params);
      }
      else {
        var element,
            url = history.state.url,
            values = url.slice(url.indexOf('?') + 1).split('&'),
            length = values.length;

        for(var i = 0; i < length; i++) {
          element = values[i].split('=');
          params.add(decodeURIComponent(element[0]), decodeURIComponent(element[1]));
        }

        // replace history state with new parameters
        searchState(params, true);
      }

      searchFetch();
    }

    function watchParams() {
      var filter_panel = '.filter-panel';
      $(watch).on('params', function (e, action, type, value) {
        // filter panel
        var text = type + ': ' + value;
        var object = {'type': type, 'value': value, 'text': text };
        switch(action) {
          case 'add':
            // params not included in filter panel
            var ignored_params = ['query', 'order', 'search_class'];
            // remove previous element if type is a single value only
            var single_params = ['year'];
            var index = single_params.indexOf(type);
            if (index > -1) {
                $.each($('.filter-panel').tagsinput('items'), function (i, v) {
                  if (v.type === single_params[index]) {
                    $(filter_panel).tagsinput('remove', { 'type': type, 'value': v.value }, {'ignore': true});
                  }
                });
            }
            // add object
            if (ignored_params.indexOf(type) === -1) {
              $(filter_panel).tagsinput('add', object);
            }
            break;
          case 'remove':
            // remove object
            $(filter_panel).tagsinput('remove', object);
            break;
        }

        // sidebar
        // set values from params
        switch(type) {
          // topic
          case 'topic':
            // var topics = params.get('topic');
            // $('.filter-topic').each(function() {
            //   if (this.value !== topics) {
            //     $(this).val(topics).trigger('change');
            //   }
            // });
            watchCheckbox('topic','filter-topic',true);
            break;
          // type
          case 'type':
            watchCheckbox('type', 'filter-type', true);
            break;
          // schoolyear
          case 'school_level':
            watchCheckbox('school_level', 'filter-school-level', true);
            break;
          case 'year':
            var year = params.get('year').split('-');
            if (year.length === 1){
              $("#filter-year input[value=single]").prop('checked',true);
              $("#filter-year input[name=singleYear]").val(year[0]);
            }
            else{
              $("#filter-year input[value=range]").prop('checked',true);
              $("#filter-year input[name=startYear]").val(year[0]);
              $("#filter-year input[name=endYear]").val(year[1]);
            }
            break;
          case 'source' :
            watchCheckbox('source', 'filter-source', true);
            break;
        }
      });
      $(watch).on('reset', function (e) {
        $(filter_panel).tagsinput('removeAll');
      });
    }

    function watchSearchInput() {
      $('.search-input input').val(params.get('query'));
      $('.search-input select').val(params.get('search_class'));
      $(document).on('submit', '.search-input form', function (event) {
        event.preventDefault();
        params.reset();
        params.add('query', $('input[name="query"]', this).val());
        var search_class = $('select[name="search_class"]', this).val()
        params.add('search_class', search_class);
        $("#search_class").val(search_class);
        searchFetch();
      });
    }

    $(document).on('click', '.pagination a', function(e) {
      e.preventDefault();
      params.add('page',$(this).html());
      searchFetch(true);
    });

    function watchFilterPanel() {
      $(document).on('beforeItemRemove', '.filter-panel', function(event) {
        if (event.options === undefined) {
          event.options = {'ignore': false};
        }
        if (event.options.ignore === false) {
          params.remove(event.item.type, event.item.value);
          filtersFetchInterval();
        }
      });
    }

    function watchOrder() {
      var select = 'select[name="order"]';
      $(document).on('change', select, function (event) {
        params.add('order', this.value);
        searchFetch();
      });
      // reset
      $(document).on('reset', watch, function (e) {
        $(select).val("");
      });
    }

    function watchFilters() {
      // watchFiltertopic();
      watchCheckbox('topic','filter-topic');
      watchCheckbox('type', 'filter-type');
      watchCheckbox('school_level', 'filter-school-level');
      watchCheckbox('source', 'filter-source');
      watchFilterYear();
      watchFilterRegex();
    }

    function watchFilterYear(){
      $('#filter-year button').on('click', function(event){
        event.preventDefault();
        value = $('#filter-year input[name=year]:checked').val();
        switch (value) {
          case "single":
            params.add('year', $('#filter-year input[name=singleYear]').val());
            break;
          case "range":
            start_year = $('#filter-year input[name=startYear]').val();
            end_year = $('#filter-year input[name=endYear]').val();
            params.add('year', start_year + '-' + end_year);
            break;
        }
        filtersFetchInterval();
      });
      // reset
      $(document).on('reset', watch, function (e) {
        $('#filter-year input[name=singleYear]').val("");
        $('#filter-year input[name=startYear]').val("");
        $('#filter-year input[name=endYear]').val("");
      });
    }

    function watchFilterRegex() {
      // $('.regex-submit').on('click', function (event) {
      //   event.preventDefault();
      //   $.each(['all','exact','any','none'], function(index, value){
      //     params.add('regex_' + value, $(".regex input[name="+value+"]").val())
      //   });
      //   filtersFetchInterval();
      // });
    }

    function watchFiltertopic() {
      // watch for changes
      // $('.filter-topic').on('select2:select', function (e) {
      //   params.add('topic', e.params.data.id);
      //
      //   filtersFetchInterval();
      // });
      // $('.filter-topic').on('select2:unselect', function (e) {
      //   params.remove('topic', e.params.data.id);
      //
      //   filtersFetchInterval();
      // });
    }

    function watchCheckbox(type, name, set) {
      var input = 'input[name="' + name + '"]';
      if (set === undefined) { set = false; }
      if (set) {
        var elements = params.get(type);
        if (elements !== undefined) {
          $(input).each(function() {
            if (elements.indexOf(this.value) > -1) {
              $(this).attr('checked', true);
            }
            else {
              $(this).attr('checked', false);
            }
          });
        }
      }
      else {
        // watch for changes
        $(document).on('click', input, function () {
          if (this.checked) {
            params.add(type, this.value);
          }
          else {
            params.remove(type, this.value);
          }

          filtersFetchInterval();
        });
        // reset
        $(document).on('reset', watch, function (e) {
          $(input).each(function () {
            $(this).attr('checked', false);
          });
        });
      }
    }

    // control ajax requisitions (fetch) of filters
    function filtersFetchInterval() {
      // cancel previous function call
      clearInterval(intervalId);
      intervalId = setInterval(function () {
        searchFetch();
        // cancel to not loop (interval)
        clearInterval(intervalId);
      }, 800);
    }
  }

  //// INIT
  // initiate params
  var params = searchParameters();
  var fetch_init = false;

  // run watchers
  searchWatchers();

  // TODO: find a way to manage all requisitions without page reload
};

//// SEARCH STATE
// take care of History API
var searchState = function(params, replace) {
  if ((replace === undefined) || (replace !== true)) { replace = false; }
  var newState = JSON.parse(JSON.stringify(history.state));
  newState.url = params.url();
  newState.search_params = params.get();

  if (replace) { history.replaceState(newState, location.href, location.href); }
  else { history.pushState(newState, newState.url, newState.url); }
}

//// SEARCH PARAMETERS
// take care of params (setters and getters)
var searchParameters = function() {
  var default_params = {
    query: "",
    page: 1,
    order: "",
    topic: [],
    type: [],
    school_level: [],
    source: [],
    year: "",
    search_class: "",
    regex_all: "",
    regex_exact: "",
    regex_any: "",
    regex_none: ""
  }

  // clone default_params
  var params = JSON.parse(JSON.stringify(default_params));

  function validate_type(type) {
    return params[type] !== undefined;
  }

  return {
    reload: function(params_new) {
      params = params_new;
      $(watch).trigger("params", ['reload', 'all']);
    },
    add: function(type, value, replace) {
      if (validate_type(type)) {
        if (replace === undefined) {
          replace = false;
        }
        // if string type or replace
        if ((typeof params[type] === "string") || (typeof params[type] === "number") || replace) {
          if (params[type] !== value) {
            params[type] = value;
            $(watch).trigger("params", ['add', type, value]);
          }
        }
        // if object, append
        else {
          if (params[type].indexOf(value) === -1) {
            params[type].push(value);
            $(watch).trigger("params", ['add', type, value]);
          }
        }
      }
    },
    remove: function(type, value) {
      if (validate_type(type)) {
        // value = encodeURIComponent(value);
        // if string type
        if ((typeof params[type] === "string") || (typeof params[type] === "number")){
          // remove element
          if (params[type] !== ""){
            params[type] = "";
            $(watch).trigger("params", ['remove', type, value]);
          }
        }
        // if object
        else {
          // remove only if element exists
          // https://stackoverflow.com/questions/18347033/how-to-shorten-my-conditional-statements/18347047#answer-18347047
          var index = params[type].indexOf(value);
          if (~index) {
            params[type].splice(index,1);
            $(watch).trigger("params", ['remove', type, value]);
          }
        }
      }
    },
    get: function(type) {
      if (type === undefined) {
        return params;
      }
      return params[type];
    },
    get_fetch: function() {
      var params_to_send = JSON.parse(JSON.stringify(params));
      params_to_send.topic = params_to_send.topic.join(', ');
      params_to_send.type = params_to_send.type.join(', ');
      params_to_send.school_level = params_to_send.school_level.join(', ');
      params_to_send.source = params_to_send.source.join('-s- ');
      return params_to_send;
    },
    url: function() {
      var url = history.state.url.split('?', 1) + "?",
          keys = Object.keys(params),
          length = keys.length;

      // check every parameter
      for (var i = 0; i < length; ++i) {
        // only get non empty values
        if (params[keys[i]].length > 0) {
          // string concat in url
          if (typeof params[keys[i]] === "string") {
            url += "&" + keys[i] + "=" + params[keys[i]];
          }
          // object can have more than one element to concat in url
          else {
            var object_length = params[keys[i]].length
            for (var j = 0; j < object_length; ++j) {
              url += "&" + encodeURIComponent(keys[i]) + "=" + encodeURIComponent(params[keys[i]][j]);
            }
          }
        }
      }
      return url;
    },
    reset: function(type) {
      if (type === undefined) {
        // reset params
        params = JSON.parse(JSON.stringify(default_params));
        $(watch).trigger("reset");
      }
      else {
        // reset params.type
        params[type] = JSON.parse(JSON.stringify(default_params[type]));
        // $(watch).trigger("params", [type, value]);
      }
    }
  };
};

//// DROPDOWN
var runDropdown = function(element) {
  if (($(element).next().data('dropdown') === 'closed')) {
    $('> .caret', element).addClass('caret-up');
    $(element).next().slideDown('slow');
    $(element).next().data('dropdown', 'open');
  }
  else {
    $('> .caret', element).removeClass('caret-up');
    $(element).next().slideUp('slow');
    $(element).next().data('dropdown',  'closed');
  }
};


$(document).ready (function(){

  var lo_num = $('.search-input input').attr("data-lo");
  var collection_num = $('.search-input input').attr("data-collection");
  var user_num = $('.search-input input').attr("data-user");

  $('.search-input input').attr('placeholder', "Buscar em " + lo_num + " conteúdos");

  $('.search-input select').change( function(){
    switch($(this).val()) {
      case 'LearningObject':
        $('.search-input input').attr('placeholder', "Buscar em " + lo_num + " conteúdos");
      break;
      case 'Collection':
        $('.search-input input').attr('placeholder', "Buscar em " + collection_num + " coleções");
      break;
      case 'User':
        $('.search-input input').attr('placeholder', "Buscar em " + user_num + " usuários");
      break;
      default:
        $('.search-input input').attr('placeholder', "Buscar conteúdo");
    }
  })

});
